#!/bin/bash

IFS=$'\t'
echo '<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE dict SYSTEM "dtd/mwetoolkit-dict.dtd">
<dict>
<meta>
</meta>'

i=0
while read -r surface pos lemma; do
	[[ $mid ]] || {
		mid=1
		echo "<entry><ngram>"
	}
	if [[ $surface = "</s>" ]]; then
		mid=
		((++i%100 == 0)) && echo "Processing item $i" >&2
		echo "</ngram></entry>"
	else
		[[ $lemma = "<unknown>" ]] && lemma="$surface"
		if [[ $1 = -s ]]; then
			echo "  <w surface=\"${surface//\"/&quot;}\"/>"
		elif [[ $1 = -L ]]; then
			echo "  <w lemma=\"${lemma//\"/&quot;}\" pos=\"$pos\"/>";
		else
			echo "  <w lemma=\"${lemma//\"/&quot;}\" pos=\"$pos\" surface=\"${surface//\"/&quot;}\"/>"
		fi
	fi
done

echo '</dict>'

