#!/bin/bash

id=0
corpusname=corpus

echo '<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE candidates SYSTEM "dtd/mwetoolkit-candidates.dtd">
<candidates >
<meta>
    <metafeat name="glue" type="real" />
</meta>'

IFS=" "
cat "$@" | while IFS=$'\t' read ngram freq glue; do
	set -- $ngram
	echo "<cand candid=\"$((id++))\">"
	echo "  <ngram>"
	for word; do
		echo "    <w lemma=\"${word%/*}\" pos=\"${word##*/}\" />"
	done
	echo "  <freq name=\"$corpusname\" value=\"$freq\" />"
	echo "  </ngram>"
	echo "  <features>"
	echo "    <feat name=\"glue\" value=\"$glue\" />"
	echo "  </features>"
	echo "</cand>"
done
echo '</candidates>'
